#!/usr/bin/env python3
# -*- encoding: utf-8; py-indent-offset: 4 -*-

#from cmk.gui.plugins.metrics import (
#   metric_info,
#   graph_info,
#)
from cmk.gui.plugins.wato import (
    register_check_parameters,
    register_rule,
)
from cmk.gui.valuespec import (
    Percentage,
    TextAscii,
    ListOfStrings,
    Dictionary,
    RegExp,
    Age,
    Tuple,
)

from cmk.gui.valuespec import Integer

register_check_parameters(
    subgroup_applications,
    "http_log_parser",
    _("HTTP Log Parser"),
    Dictionary(
        elements=[
            ("failure_rate",
             Tuple(
                 title=_("Check Failure Rate"),
                 elements=[
                     Percentage(title=_("Warning if higher than"),
                                help=_("Generate a WARNING if the failure rate is higher than the configured value.")),
                     Percentage(title=_("Critical if higher than"),
                                help=_("Generate a CRITICAL if the failure rate is higher than the configured value.")),
                 ]
             )),
            #("count_101",
            # Tuple(
            #     title=_("Check Count of 101 Responses"),
            #     elements=[
            #         Integer(title=_("Warning if higher than"),
            #                 help=_("Generate a WARNING if the count of 101 responses is higher than the configured value.")),
            #         Integer(title=_("Critical if higher than"),
            #                 help=_("Generate a CRITICAL if the count of 101 responses is higher than the configured value.")),
            #     ]
            # )),
            ("count_1XX",
             Tuple(
                 title=_("Check Count of 1XX Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 1XX responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 1XX responses is higher than the configured value.")),
                 ]
             )),
            ("count_2XX",
             Tuple(
                 title=_("Check Count of 2XX Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 2XX responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 2XX responses is higher than the configured value.")),
                 ]
             )),
            ("count_3XX",
             Tuple(
                 title=_("Check Count of 3XX Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 3XX responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 3XX responses is higher than the configured value.")),
                 ]
             )),
            ("count_400",
             Tuple(
                 title=_("Check Count of 400 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 400 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 400 responses is higher than the configured value.")),
                 ]
             )),
            ("count_401",
             Tuple(
                 title=_("Check Count of 401 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 401 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 401 responses is higher than the configured value.")),
                 ]
             )),
            ("count_403",
             Tuple(
                 title=_("Check Count of 403 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 403 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 403 responses is higher than the configured value.")),
                 ]
             )),
            ("count_404",
             Tuple(
                 title=_("Check Count of 404 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 404 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 404 responses is higher than the configured value.")),
                 ]
             )),
            ("count_499",
             Tuple(
                 title=_("Check Count of 499 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 499 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 499 responses is higher than the configured value.")),
                 ]
             )),
            ("count_4XX",
             Tuple(
                 title=_("Check Count of 4XX Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 4XX responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 4XX responses is higher than the configured value.")),
                 ]
             )),
            ("count_500",
             Tuple(
                 title=_("Check Count of 500 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 500 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 500 responses is higher than the configured value.")),
                 ]
             )),
            ("count_502",
             Tuple(
                 title=_("Check Count of 502 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 502 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 502 responses is higher than the configured value.")),
                 ]
             )),
            ("count_503",
             Tuple(
                 title=_("Check Count of 503 Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 503 responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 503 responses is higher than the configured value.")),
                 ]
             )),
            ("count_5XX",
             Tuple(
                 title=_("Check Count of 5XX Responses"),
                 elements=[
                     Integer(title=_("Warning if higher than"),
                             help=_("Generate a WARNING if the count of 5XX responses is higher than the configured value.")),
                     Integer(title=_("Critical if higher than"),
                             help=_("Generate a CRITICAL if the count of 5XX responses is higher than the configured value.")),
                 ]
             )),
            # Add similar entries for count_3XX, count_4XX, and count_5XX
        ],
    ),
    TextAscii(
        title=_("Log File"),
        help=_("The full path of the logfile.")
    ),
    "dict"
)



register_rule(
    "agents/" + _("Agent Plugins"),
    "agent_config:http_log_parser",
    Alternative(
        title=_("HTTP Log Parser"),
        help=_("This will deploy the agent plugin <tt>http_log_parser</tt> "
               "for checking various HTTP access logs of webservers "
               "like Apache, Nginx, Tomcat. It counts the latest number of requests "
               "per status code for a configurable period of time."
               ),
        style="dropdown",
        elements=[
            Dictionary(
                title=_("Deploy the HTTP Log Parser plugin"),
                elements=[
                    ("log_files",
                     ListOfStrings(
                         title=_("Logfile Patterns"),
                         help=_('A list of additional access log file patterns that should be considered for discovery. The path can contain globbing wildcards (<tt>*</tt> & <tt>?</tt>) to mask variable parts. Only the newest file which matches a pattern will be used for analysis.'),
                         valuespec=TextAscii(
                             size=80,
                             regex="^/(/?[^\0/])+|/$",
                             regex_error=_("Logfile pattern must begin with <tt>/</tt>."),
                         ),
                         allow_empty=False,
                     )
                     ),
                    ("read_back",
                     Age(
                         title=_("Readback Age"),
                         help=_('The time period which should be considered when reading the access logfile (based on the current time'),
                         display=["minutes", "seconds"],
                         label="reading the last",
                         default_value=300
                     )
                     ),
                    ("line_regexp",
                     ListOfStrings(
                         title=_("Line Regexp Patterns"),
                         help=_("A list of custom regular expression which will be applied against each line of the access log file to extract the date and response status."
                                "The pattern must be capture the date as named group 'date' (via <tt>(?P<date>.+)</tt> and the status as named group 'status' (via <tt>(?P<status>\d+)</tt><br><br>"
                                ),
                         allow_empty=False,
                         valuespec=RegExp(
                             size=80,
                             regex="^(?=.*\(\?P\<status\>)(?=.*\(\?P\<date\>).*$",
                             regex_error=_("The regular expression does not contain both group captures to extract the date <tt>(?P<date>.+)</tt> and status code <tt>(?P<status>\d+)</tt><br><br>Please add both named groups!"),
                             mingroups=2,
                             maxgroups=2,
                             mode="prefix"
                         ),
                         default_value=[r'^(?:\S+\s+)+\[(?P<date>[^\]]+) \+\d\d\d\d\]\s+"[^"]*"\s+(?P<status>\d+)']
                     )
                     ),
                    ("date_formats",
                     ListOfStrings(
                         title=_("Date Format Strings"),
                         help=_("A list of custom date format string which will be used to parse a date/time entry which is extracted by a line regexp to determine the exact timestamp of a request. The python function datetime.strptime() will be used for this, see Python documentation (<tt>https://docs.python.org/3/library/datetime.html#strftime-and-strptime-format-codes</tt>) to get the full list of placeholders."),
                         allow_empty=False,
                         valuespec=TextAscii(
                             size=80,
                             regex=r"^.*%.*$",
                             regex_error=_("The given pattern does not contain any placeholder to extract date/time informations.")
                         )
                     )
                     )
                ],
                optional_keys=True,
            ),
            FixedValue(None, title=_("Do not deploy the HTTP Log Parser plugin"), totext=_("(disabled)")),
        ],
    ),
    match="dict"
)
